[debian-mysql] Bug#928077: mariadb-server-10.3: fails to start. init files don't create directory /run/mysqld
Michael Farmbauer
deb-bug at baldrian.franken.de
Sat Apr 27 15:26:21 BST 2019
Package: mariadb-server-10.3
Version: 1:10.3.14-1
Severity: grave
Justification: renders package unusable
Dear Maintainer,
in the latest update the pid and socket files have been moved from
/var/run/mysqld to /run/mysqld.
The directory /run/mysqld must be created in the init files:
/etc/init.d/mysql
/var/lib/systemd/system/mariadb*
Those file still create the directory /var/run/mysqld
I have also changed some configuration file to honor the new location of
the pid and socket files:
/etc/mysql/mariadb.conf.d/50-client.cnf
/etc/mysql/mariadb.conf.d/50-mysqld_safe.cnf
/etc/mysql/debian.cnf
Regards,
Michael Farmbauer
-- System Information:
Debian Release: buster/sid
APT prefers testing
APT policy: (500, 'testing')
Architecture: amd64 (x86_64)
Kernel: Linux 4.19.0-4-amd64 (SMP w/4 CPU cores)
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8), LANGUAGE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash
Init: systemd (via /run/systemd/system)
Versions of packages mariadb-server-10.3 depends on:
ii adduser 3.118
ii debconf [debconf-2.0] 1.5.71
ii galera-3 25.3.25-2
ii gawk 1:4.2.1+dfsg-1
ii iproute2 4.20.0-2
ii libc6 2.28-8
ii libdbi-perl 1.642-1+b1
ii libgnutls30 3.6.6-2
ii libpam0g 1.3.1-5
ii libstdc++6 8.3.0-6
ii lsb-base 10.2019031300
ii lsof 4.91+dfsg-1
ii mariadb-client-10.3 1:10.3.14-1
ii mariadb-common 1:10.3.14-1
ii mariadb-server-core-10.3 1:10.3.14-1
ii passwd 1:4.5-1.1
ii perl 5.28.1-6
ii psmisc 23.2-1
ii rsync 3.1.3-6
ii socat 1.7.3.2-2
ii zlib1g 1:1.2.11.dfsg-1
Versions of packages mariadb-server-10.3 recommends:
ii libhtml-template-perl 2.97-1
Versions of packages mariadb-server-10.3 suggests:
ii bsd-mailx [mailx] 8.1.2-0.20180807cvs-1
ii mailutils [mailx] 1:3.5-3
pn mariadb-test <none>
ii netcat-openbsd 1.195-2
pn tinyca <none>
-- Configuration Files:
/etc/init.d/mysql changed:
set -e
set -u
${DEBIAN_SCRIPT_DEBUG:+ set -v -x}
test -x /usr/sbin/mysqld || exit 0
. /lib/lsb/init-functions
SELF=$(cd $(dirname $0); pwd -P)/$(basename $0)
MYADMIN="/usr/bin/mysqladmin --defaults-file=/etc/mysql/debian.cnf"
ERR_LOGGER="logger -p daemon.err -t /etc/init.d/mysql -i"
if [ -f /etc/default/mysql ]; then
. /etc/default/mysql
fi
if [ -f /etc/default/mariadb ]; then
. /etc/default/mariadb
fi
cd /
umask 077
export HOME=/etc/mysql/
mysqld_get_param() {
/usr/sbin/mysqld --print-defaults \
| tr " " "\n" \
| grep -- "--$1" \
| tail -n 1 \
| cut -d= -f2
}
sanity_checks() {
# check for config file
if [ ! -r /etc/mysql/my.cnf ]; then
log_warning_msg "$0: WARNING: /etc/mysql/my.cnf cannot be read. See README.Debian.gz"
echo "WARNING: /etc/mysql/my.cnf cannot be read. See README.Debian.gz" | $ERR_LOGGER
fi
# check for diskspace shortage
datadir=`mysqld_get_param datadir`
if LC_ALL=C BLOCKSIZE= df --portability $datadir/. | tail -n 1 | awk '{ exit ($4>4096) }'; then
log_failure_msg "$0: ERROR: The partition with $datadir is too full!"
echo "ERROR: The partition with $datadir is too full!" | $ERR_LOGGER
exit 1
fi
}
mysqld_status () {
ping_output=`$MYADMIN ping 2>&1`; ping_alive=$(( ! $? ))
ps_alive=0
pidfile=`mysqld_get_param pid-file`
if [ -f "$pidfile" ] && ps `cat $pidfile` >/dev/null 2>&1; then ps_alive=1; fi
if [ "$1" = "check_alive" -a $ping_alive = 1 ] ||
[ "$1" = "check_dead" -a $ping_alive = 0 -a $ps_alive = 0 ]; then
return 0 # EXIT_SUCCESS
else
if [ "$2" = "warn" ]; then
echo -e "$ps_alive processes alive and '$MYADMIN ping' resulted in\n$ping_output\n" | $ERR_LOGGER -p daemon.debug
fi
return 1 # EXIT_FAILURE
fi
}
case "${1:-''}" in
'start')
sanity_checks;
# Start daemon
log_daemon_msg "Starting MariaDB database server" "mysqld"
if mysqld_status check_alive nowarn; then
log_progress_msg "already running"
log_end_msg 0
else
# Could be removed during boot
test -e /run/mysqld || install -m 755 -o mysql -g root -d /run/mysqld
# Start MariaDB!
/usr/bin/mysqld_safe "${@:2}" 2>&1 >/dev/null | $ERR_LOGGER &
for i in $(seq 1 "${MYSQLD_STARTUP_TIMEOUT:-30}"); do
sleep 1
if mysqld_status check_alive nowarn ; then break; fi
log_progress_msg "."
done
if mysqld_status check_alive warn; then
log_end_msg 0
# Now start mysqlcheck or whatever the admin wants.
output=$(/etc/mysql/debian-start)
if [ -n "$output" ]; then
log_action_msg "$output"
fi
else
log_end_msg 1
log_failure_msg "Please take a look at the syslog"
fi
fi
;;
'stop')
# * As a passwordless mysqladmin (e.g. via ~/.my.cnf) must be possible
# at least for cron, we can rely on it here, too. (although we have
# to specify it explicit as e.g. sudo environments points to the normal
# users home and not /root)
log_daemon_msg "Stopping MariaDB database server" "mysqld"
if ! mysqld_status check_dead nowarn; then
set +e
shutdown_out=`$MYADMIN shutdown 2>&1`; r=$?
set -e
if [ "$r" -ne 0 ]; then
log_end_msg 1
[ "$VERBOSE" != "no" ] && log_failure_msg "Error: $shutdown_out"
log_daemon_msg "Killing MariaDB database server by signal" "mysqld"
killall -15 mysqld
server_down=
for i in `seq 1 600`; do
sleep 1
if mysqld_status check_dead nowarn; then server_down=1; break; fi
done
if test -z "$server_down"; then killall -9 mysqld; fi
fi
fi
if ! mysqld_status check_dead warn; then
log_end_msg 1
log_failure_msg "Please stop MariaDB manually and read /usr/share/doc/mariadb-server-10.3/README.Debian.gz!"
exit -1
else
log_end_msg 0
fi
;;
'restart')
set +e; $SELF stop; set -e
shift
$SELF start "${@}"
;;
'reload'|'force-reload')
log_daemon_msg "Reloading MariaDB database server" "mysqld"
$MYADMIN reload
log_end_msg 0
;;
'status')
if mysqld_status check_alive nowarn; then
log_action_msg "$($MYADMIN version)"
else
log_action_msg "MariaDB is stopped."
exit 3
fi
;;
'bootstrap')
# Bootstrap the cluster, start the first node
# that initiates the cluster
log_daemon_msg "Bootstrapping the cluster" "mysqld"
$SELF start "${@:2}" --wsrep-new-cluster
;;
*)
echo "Usage: $SELF start|stop|restart|reload|force-reload|status|bootstrap"
exit 1
;;
esac
/etc/logcheck/ignore.d.paranoid/mariadb-server-10_3 [Errno 13] Permission denied: '/etc/logcheck/ignore.d.paranoid/mariadb-server-10_3'
/etc/logcheck/ignore.d.server/mariadb-server-10_3 [Errno 13] Permission denied: '/etc/logcheck/ignore.d.server/mariadb-server-10_3'
/etc/logcheck/ignore.d.workstation/mariadb-server-10_3 [Errno 13] Permission denied: '/etc/logcheck/ignore.d.workstation/mariadb-server-10_3'
/etc/mysql/mariadb.conf.d/50-mysqld_safe.cnf changed:
[mysqld_safe]
socket = /run/mysqld/mysqld.sock
nice = 0
skip_log_error
syslog
-- debconf information excluded
More information about the pkg-mysql-maint
mailing list